var Queue = function(object) {
    this.counter = 1
    this.masterFunction = null
    if(object[0] instanceof Function) {
        this.queue = Object.entries(object)
        this.sharedObject = {}
    } else {
        this.queue = Object.entries(object)
        this.sharedObject = this.queue.shift()[1] || {}
    }
    this.queueLength = this.queue.length
}

Queue.prototype.next = function() {
    if(this.queueLength == this.counter) {
        var callback = this.queue.shift()[1]
        this.masterFunction(this.sharedObject, this.queue)
        .then(function(response) {
            callback(false, {lCode: response.lCode || '-S', msg: response.msg || 'Sikeres lefutás!', type: response.type || 'success', document: response.document || null})
        })
        .catch(function(response) {
            if(global.DEVELOPERMODE.NORMAPIERRORS) {console.dev.log(response)}
            callback(true, {lCode: response.lCode || '-E', msg: response.msg || 'Sikertelen lefutás!', type: response.type || 'error'})
        })
    }
    else {
        ++this.counter
        return this.queue.shift()[1](this.sharedObject, this)
    }
}

Queue.prototype.stop = function(object) {
    var callback = this.queue.pop()[1]
    this.queue = null
    callback(true, {lCode: object.lCode || '-E2', msg: object.msg || 'Sikertelen lefutás!', type: object.type || 'queue-error'})
}

Queue.prototype.setMasterFunction = function(masterFunction) {
    this.masterFunction = masterFunction
}

module.exports = Queue